/*
 * Antonio Ronaldo Nugoli 
 * Rgm: 015724
 * Universidade Estadual de Mato  Grosso do Sul - UEMS
 * Sistemas de Informao
 * Projeto Final de Curso II
 * 
 * Implementao de um Game Interativo Utilizando a Biblioteca OpenCV
 * Jogo: Nugoli Racing Web Cam
 * 
 * Descrio da Classe:
 * Classe para gerenciar o sprite do jogador e suas posies na tela
 */

package jogo;

import java.awt.Image;
import java.awt.event.KeyEvent;

import javax.swing.ImageIcon;

public class Jogador {

	private int x, y, dx, largura, larg, alt, atual = 0, altura;
	private Image[] carJogador;

	// Diz se o jogador est sendo movido ou no
	private Boolean emuso;
	
	// O construtor carrega a imagem do carro e ajuasta sua proporo em relao a resoluo de tela
	public Jogador(int largura, int altura) {
		carregaCar();
		this.largura = largura;
		this.altura = altura;
		x = largura / 2 - carJogador[1].getWidth(null) / 2 + 50;
		y = altura - altura * 45 / carJogador[1].getHeight(null) - 30;
		larg = largura * 55 / carJogador[1].getWidth(null);
		alt = altura * 50 / carJogador[1].getHeight(null);
		emuso = false;
	}

	// Carrega as trs imagens possiveis do sprite do jogador  escolhida pela
	// variavel (atual)
	private void carregaCar() {
		carJogador = new Image[3];
		ImageIcon referencia = new ImageIcon("img\\celta.png");
		carJogador[0] = referencia.getImage();

		referencia = new ImageIcon("img\\celtaDireita.png");
		carJogador[1] = referencia.getImage();

		referencia = new ImageIcon("img\\celtaEsquerda.png");
		carJogador[2] = referencia.getImage();

	}

	// Seta a imagem do carro que o sprites deve assumir
	public void setAtual(int atual) {
		this.atual = atual;
	}

	public Boolean getEmuso() {
		return emuso;
	}

	public int getLargura() {
		return largura;
	}

	public int getAltura() {
		return altura;
	}

	public Image getJogador() {
		return carJogador[atual];
	}

	public int getX() {
		return x;
	}

	public int getY() {
		return y;
	}

	public int getLarg() {
		return larg;
	}

	public int getAlt() {
		return alt;
	}

	public void atualiza() {
		x += dx;

	}

	public void setDx(int dx) {
		this.dx = dx;
	}

	public void setX(int x) {
		this.x = x;
	}

	// Caso queira movimentar o jogador com as setas do teclado
	public void keyPressed(KeyEvent e) {
		if (e.getKeyCode() == KeyEvent.VK_LEFT) {
			if (x > ((largura * 13) / 100))
				dx = -8;
			else
				dx = 0;
			atual = 1;
			emuso = true;

		}
		if (e.getKeyCode() == KeyEvent.VK_RIGHT) {
			if (x < ((largura * 67) / 100))
				dx = 8;
			else
				dx = 0;
			atual = 2;
			emuso = true;
		}

	}

	public void keyReleased(KeyEvent e) {
		if (e.getKeyCode() == KeyEvent.VK_LEFT) {
			dx = 0;
			atual = 0;
			emuso = false;
		}
		if (e.getKeyCode() == KeyEvent.VK_RIGHT) {
			dx = 0;
			atual = 0;
			emuso = false;
		}

	}

}
