/*
 * Antonio Ronaldo Nugoli 
 * Rgm: 015724
 * Universidade Estadual de Mato  Grosso do Sul - UEMS
 * Sistemas de Informao
 * Projeto Final de Curso II
 * 
 * Implementao de um Game Interativo Utilizando a Biblioteca OpenCV
 * Jogo: Nugoli Racing Web Cam
 * 
 * Descrio da Classe:
 * Converter uma variavel Mat para uma BufferedImage
 * Adaptado do site https://github.com/gurkan0791/Java-OpenCV-Example/blob/master/src/MatToBufImg.java
 */

package jogo;

import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.InputStream;

import javax.imageio.ImageIO;

import org.opencv.core.Mat;
import org.opencv.core.MatOfByte;
import org.opencv.highgui.Highgui;

public class MatParaBuff {
	Mat matrix;
	MatOfByte mob;
	String fileExten;

	// The file extension string should be ".jpg", ".png", etc
	public MatParaBuff() {
	}

	// Devem ser passado como parmetros extenses de arquivo de imagem do tipo ".jpg", ".png", etc
	public MatParaBuff(Mat amatrix, String fileExt) {
		matrix = amatrix;
		fileExten = fileExt;
	}

	public void setMatrix(Mat amatrix, String fileExt) {
		matrix = amatrix;
		fileExten = fileExt;
		mob = new MatOfByte();
	}

	public BufferedImage getBufferedImage() {
		
		// Converte a matriz em uma materiz de bytes apropriada para a exteno 
		Highgui.imencode(fileExten, matrix, mob);
		byte[] byteArray = mob.toArray();
		BufferedImage bufImage = null;
		try {
			InputStream in = new ByteArrayInputStream(byteArray);
			bufImage = ImageIO.read(in);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return bufImage;
	}
}
