/*
 * Antonio Ronaldo Nugoli 
 * Rgm: 015724
 * Universidade Estadual de Mato  Grosso do Sul - UEMS
 * Sistemas de Informao
 * Projeto Final de Curso II
 * 
 * Implementao de um Game Interativo Utilizando a Biblioteca OpenCV
 * Jogo: Nugoli Racing Web Cam
 * 
 * Descrio da Classe:
 * Classe com toda a informao sobre o seguimento de pista 
 */

package jogo;

import java.awt.image.BufferedImage;

public class Pista {
	private float x = 0, y = 0, X = 0, Y = 0, W = 0, scala, curva = 0, z = 0, img_cenariox = 0, clip, ajuste = 0,
			camD = (float) 0.84;
	private int largura, altura;
	private BufferedImage img_cenario = null;
	private int coordeCenario[] = { 0, 0, 0, 0, 0, 0 };
	private boolean carro = false;

	public boolean isCarro() {
		return carro;
	}

	// Cria um segmento de pista levando em considerao a resoluo da tela
	public Pista(int largura, int altura) {
		this.largura = largura;
		this.altura = altura;
	}

	//Ser usada pela RenderPista para calcular as escalas de projeo na tela 
	public void projetar(float CamX, float CamY, float CamZ) {
		scala = camD / (z - CamZ);
		X = (1 + scala * (x - CamX)) * largura / 2;
		Y = (1 - scala * (y - CamY)) * altura / 2;
		W = scala * 900 * largura / 2;
	}

	//Calcula a coordenada de exibio do segmento de pista na tela
	public int[] desenhaObjetos() {
		int w = img_cenario.getWidth();
		int h = img_cenario.getHeight();
		float destX = X + scala * img_cenariox * largura / 2;
		float destY = Y + 8;
		float destW = (w * W) / 266;
		float destH = (h * W) / 266;
		destX += destW * img_cenariox;
		destY += destH * (-1);
		float clipH = destY + destH - clip;
		if (clipH < 0)
			clipH = 0;
		if (clipH >= destH)
			return coordeCenario;
		if ((h - h * (int) clipH / (int) destH) > 0) {
			destH = ((h - h * (int) clipH / (int) destH) * W) / 266;
			coordeCenario[0] = ((int) destX);
			coordeCenario[1] = ((int) destY);
			coordeCenario[2] = ((int) destW);
			coordeCenario[3] = ((int) destH);
			coordeCenario[4] = (w);
			coordeCenario[5] = ((h - h * (int) clipH / (int) destH));
		}

		return coordeCenario;
	}

	public void setCarro(boolean carro) {
		this.carro = carro;
	}

	public float getScala() {
		return scala;
	}

	public void setScala(float scala) {
		this.scala = scala;
	}

	public float getImg_cenariox() {
		return img_cenariox;
	}

	public void setImg_cenariox(float img_cenariox) {
		this.img_cenariox = img_cenariox;
	}

	public float getAjuste() {
		return ajuste;
	}

	public void setAjuste(float ajuste) {
		this.ajuste = ajuste;
	}

	public float getClip() {
		return clip;
	}

	public void setClip(float clip) {
		this.clip = clip;
	}

	public BufferedImage getImg_cenario() {
		return img_cenario;
	}

	public void setImg_cenario(BufferedImage img_cenario) {
		this.img_cenario = img_cenario;
	}

	public float getCurva() {
		return curva;
	}

	public void setCurva(float curva) {
		this.curva = curva;
	}

	public float getZ() {
		return z;
	}

	public float getX() {
		return X;
	}

	public float getY() {
		return Y;
	}

	public float gety() {
		return y;
	}

	public float getW() {
		return W;
	}

	public float getx() {
		return x;
	}

	public void setZ(int z) {
		this.z = z;
	}

	public void setx(int x) {
		this.x = x;
	}

	public void setW(float w) {
		W = w;
	}

	public void sety(float y2) {
		y = y2;
	}

	public void setX(float x) {
		X = x;
	}

	public void setY(float y) {
		Y = y;
	}

}
