/*
 * Antonio Ronaldo Nugoli 
 * Rgm: 015724
 * Universidade Estadual de Mato  Grosso do Sul - UEMS
 * Sistemas de Informao
 * Projeto Final de Curso II
 * 
 * Implementao de um Game Interativo Utilizando a Biblioteca OpenCV
 * Jogo: Nugoli Racing Web Cam
 * 
 * Descrio da Classe:
 * Criar uma rea na parte superior central da tela do jogo para mostrar as imagens da webcam
 * 
 */

package telas;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.image.BufferedImage;

public class Camera {
	private BufferedImage image;

	public void Desenha(Graphics g, int largura, int altura) {
		Graphics2D graficos = (Graphics2D) g;
		graficos.clearRect((800 / 2) - (largura / 2), 10, largura, altura);
		
		//Configura parametros para exibo das imagem na tela
		graficos.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		graficos.setRenderingHint(RenderingHints.KEY_COLOR_RENDERING, RenderingHints.VALUE_COLOR_RENDER_QUALITY);
		graficos.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);

		//Delimita cor de fundo e desenha imagem na tela na parte central superior da tela do jogo
		graficos.setColor(Color.WHITE);
		graficos.drawImage(image, 800 / 2 - largura / 2, 20, largura, altura, null);
		graficos.dispose();
	}

	//Recebe e envia imagem da webcam para apresentao na tela
	public BufferedImage getImage() {
		return image;
	}

	public void setImage(BufferedImage image) {
		this.image = image;
	}

}
