/*
 * Antonio Ronaldo Nugoli 
 * Rgm: 015724
 * Universidade Estadual de Mato  Grosso do Sul - UEMS
 * Sistemas de Informao
 * Projeto Final de Curso II
 * 
 * Implementao de um Game Interativo Utilizando a Biblioteca OpenCV
 * Jogo: Nugoli Racing Web Cam
 * 
 * Descrio da Classe:
 * Criar uma nova tela contendo opes de resoluo para que o jogador posssa escolher o tamanho da tela do jogo
 * 
 */

package telas;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

public class Resolucao extends JFrame implements MouseListener, ActionListener {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private int altura, largura, tipoResolucao;
	private TelaPrincipal tela, novatela;
	private JRadioButton rdBt1, rdBt2, rdBt3;
	private ImageIcon[] imgBtOk;
	private JButton btOk;
	private boolean selecionado = false;

	//Cria a janela com botes e uma rea para escolha de resolues
	public Resolucao() {

		setTitle("Resolu\u00E7\u00E3o");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setSize(400, 300);
		setLocationRelativeTo(null);
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		imgBtOk = new ImageIcon[2];
		imgBtOk[0] = new ImageIcon("img\\bt_ok\\btOK1.png");
		imgBtOk[1] = new ImageIcon("img\\bt_ok\\btOK2.png");
		add(areaDeEscolha());
	}

	// Define o posicionamento de cada elemento na rea destinada ao campo de escolha de resoluo
	public JPanel areaDeEscolha() {
		JPanel area = new JPanel();
		area.setLayout(null);
		area.setBackground(new Color(107, 107, 182));
		area.setBorder(null);

		btOk = new JButton();
		btOk.setIcon(imgBtOk[1]);
		btOk.setBorder(null);
		btOk.setBorderPainted(false);
		btOk.setFocusable(false);
		btOk.setContentAreaFilled(false);
		btOk.addMouseListener(this);

		rdBt2 = new JRadioButton("800 x 600");
		rdBt3 = new JRadioButton("1024 x 768");
		rdBt1 = new JRadioButton("600 x 400");

		rdBt1.setBounds(120, 30, 150, 40);
		rdBt2.setBounds(120, 80, 150, 40);
		rdBt3.setBounds(120, 130, 150, 40);

		rdBt1.addActionListener(this);
		rdBt2.addActionListener(this);
		rdBt3.addActionListener(this);

		btOk.setBounds(120, 200, 150, 40);
		btOk.setFocusPainted(false);

		rdBt1.setFont(new Font("Century Gothic", Font.BOLD, 24));
		rdBt1.setBackground(new Color(107, 107, 182));
		rdBt1.setForeground(new Color(255, 255, 255));
		rdBt1.setFocusPainted(false);

		rdBt2.setFont(new Font("Century Gothic", Font.BOLD, 24));
		rdBt2.setBackground(new Color(107, 107, 182));
		rdBt2.setForeground(new Color(255, 255, 255));
		rdBt2.setFocusPainted(false);

		rdBt3.setFont(new Font("Century Gothic", Font.BOLD, 24));
		rdBt3.setBackground(new Color(107, 107, 182));
		rdBt3.setForeground(new Color(255, 255, 255));
		rdBt3.setFocusPainted(false);

		area.add(rdBt1);
		area.add(rdBt2);
		area.add(rdBt3);
		area.add(btOk);

		return area;
	}

	//Guarda o objeto que instanciou o objeto resoluo
	public void enviaFrame(TelaPrincipal tela1) {
		this.tela = tela1;
	}

	//Eventos de Mouse para capturar o click do jogador
	@Override
	public void mouseClicked(MouseEvent e) {
		//Ao clicar em Ok caso a escolha seja invalida apenas sai da tela ou cria uma nova janela inicial passando a nova resoluo
		if (e.getSource() == btOk)

			if (selecionado) {
							
				if (!rdBt1.isSelected() && !rdBt2.isSelected() && !rdBt3.isSelected()) {
					tela.setVisible(true);
				} else {
					novatela = new TelaPrincipal(largura, altura, tipoResolucao);
					novatela.setVisible(true);
				}
			} else
				tela.setVisible(true);
		dispose();
	}

	@Override
	public void mouseEntered(MouseEvent e) {
		if (e.getSource() == btOk) {
			btOk.setIcon(imgBtOk[0]);
		}
	}

	@Override
	public void mouseExited(MouseEvent e) {
		if (e.getSource() == btOk) {
			btOk.setIcon(imgBtOk[1]);
		}
	}

	@Override
	public void mousePressed(MouseEvent e) {

	}

	@Override
	public void mouseReleased(MouseEvent e) {

	}

	//Define o tipo de Largura escolhida pelo jogador 2 - 400x600, 1  -600x800 e  0 768x1024; 
	@Override
	public void actionPerformed(ActionEvent e) {

		if (e.getSource() == rdBt1) {
			if (rdBt1.isSelected()) {
				rdBt3.setSelected(false);
				rdBt2.setSelected(false);
				altura = 400;
				largura = 600;
				selecionado = true;
				tipoResolucao = 2;
			}
		}
		if (e.getSource() == rdBt2) {
			if (rdBt2.isSelected()) {
				rdBt1.setSelected(false);
				rdBt3.setSelected(false);
				altura = 600;
				largura = 800;
				selecionado = true;
				tipoResolucao = 1;
			}
		}
		if (e.getSource() == rdBt3) {
			if (rdBt3.isSelected()) {
				rdBt1.setSelected(false);
				rdBt2.setSelected(false);
				altura = 768;
				largura = 1024;
				selecionado = true;
				tipoResolucao = 0;
			}
		}
	}

}
